package com.seer.teach.teacher.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.seer.teach.teacher.module.entity.VersionsEntity;

import java.util.Collection;
import java.util.HashMap;
import java.util.List;

/**
 * <p>
 * 教材版本表 服务类
 * </p>
 *
 * @author Wang
 * @since 2025-10-09 15:20:37
 */
public interface VersionsService extends IService<VersionsEntity> {

        /**
     * 获取指定学科的默认版本ID
     *
     * @param subjectId 学科ID
     * @return 默认版本ID，如果未找到则返回null
     */
    Integer getDefaultVersionId(Integer subjectId);

    Integer getPrimarySchool(Integer subjectId);

    Integer getMiddleSchool(Integer subjectId);

    Integer getHighSchool(Integer subjectId);

    /**
     * 根据知识点ID获取对应的学科ID
     *
     * @param knowId 知识点ID
     * @return 学科ID，如果未找到则返回null
     */
    Integer getSubjectIdByKnowID(Integer knowId);

    HashMap<Integer,Integer> getSubjectIdsByKnowIds(List<Integer> knowIds);

    /**
     * 根据学科ID获取对应的教材版本列表
     *
     * @param subjectId 学科ID
     * @return 教材版本列表
     */
    List<VersionsEntity> getListBySubjectId(Integer subjectId);

    /**
     * 根据学科ID获取对应的教材版本列表
     *
     * @param subjectIds 学科ID
     * @return 教材版本列表
     */
    List<VersionsEntity> getListBySubjectIds(Collection<Integer> subjectIds);
}
